#include<stdiostr.h>
#include<stdlib.h>
int main(int case1, char*case2[])
{
	//Open 2 files:
   FILE*data_in;	//data_in reads in the data
   FILE*mch_code;	//mch_code reads in the machine code
   int instr;	/*this keep track of the # of instruction executed*/
   int i, lstsiz; //instruction size
   int ac=0, CAR;/*ac is the accumulator,  CAR is the instruction register*/
   int  e, dr;  /*e is the carry out,   dr is the data register*/
   int I;		/*I is the 15th bit */
   int memory[255], clock; /*memory[255] is the memory, */
   int opcode;	/*Opcode is the first 4 bits of mch_code*/
   int ar=0;    /*ar is the address register*/
   int pc=100;  /* pc is the program counter*/
   if(case1!=3)
       return 1;

   //Reading in what is in data_in and mch_code
   //data_in will read in hex numbers and will be the 1st argument
   //mch_code will read in the assembled code and will be the 2nd argument
   data_in=fopen(case2[1], "rt");
   mch_code=fopen(case2[2], "rt");

   //2 locations to be used in subtraction
   memory[0x53]=1;
   memory[0x56]=-1;

   memory[0x50]=1;   /* This is the lower bound stored at 0x50*/

 
lstsiz=50;
   memory[0x51]=lstsiz;

   
   scanf("%x", &memory[0x54]);

   //A loop to store the data in memory
   for(i=1;i<lstsiz+1;i++)
   {
      fscanf(data_in,"%x",&memory[i]);

   }

   //A loop to store the assembled code in memory
   for(i=0x02;i<0x8D;i++)
   {
       fscanf(mch_code,"%x",&memory[i]);

   }

   clock=1;    /*Initializing the clock to 1*/
   instr=1;  /*initializing the instruction counter to 1*/
   //An infinite while loop to do a binary search
   while(1)
   {
      /*Fetch instruction*/
      ar=pc;

      clock++;
      CAR=memory[ar];
      pc=pc+1;

      /*Decode instruction*/
      instr++;
      clock++;
      if((CAR>0x7000)&&(CAR<0x8000))
		opcode=CAR;
      else
	       opcode=(CAR&0xF000);
      ar=(CAR&0x0FFF);

      clock++;

      //Switch statment is used to choose which one of the
      //instructions listed below to be executed
      switch(opcode)
      {

       /*Add instruction*/
       case 0x1000:
       instr++;
	    dr=memory[ar];
	    ac=ac+dr;
	    clock++;
       break;

       /*Direct load instruction*/
       case 0x2000:
       instr++;
	    dr=memory[ar];
	    clock++;
	    ac=dr;
       break;

       /*Store instruction*/
       case 0x3000:
       instr++;
	    memory[ar]=ac;
       break;

       /*Branch instruction*/
       case 0x4000:
       instr++;
	    pc=ar;
       break;

       /*Clear the carry out*/
       case 0x7800:
       instr++;
	    e=0;
       break;

       /*Complement the accumulator*/
       case 0x7400:
       instr++;
       ac=-ac;
       break;

       /*Do a right shift: division*/
       case 0x7080:
       instr++;
       ac=ac/2;
       break;

	      /*Do a left shift: division*/
       case 0x7040:
       instr++;
       ac=ac/2;
       break;

       /*Skip next instruction if ac is positive*/
       case 0x7010:
       instr++;
	      if(ac>0)
	       pc=pc+1;
       break;

       /*Skip next instruction if ac is negative*/
       case 0x7008:
       instr++;
	     if(ac<0)
	       pc=pc+1;
       break;

       /*Skip next instruction if ac is zero*/
       case 0x7004:
       instr++;
	   if(!ac)
	      pc=pc+1;
       break;

       /*Halt instruction*/
       case 0x7002:
       cout<<"\n Loading bin_srch.hex into program memory ";
       cout<<" starting at address $02... "<<endl;
       cout<<" Loading data.txt into data memory ";
       cout<<" starting at address $001... "<<endl;
       cout<<" "<<lstsiz<<" data bytes loaded "<<endl;
       cout<<" Initializing pc and other CPU registers... "<<endl;
       cout<<" Initialzing ac and ar to 0... "<<endl;
       cout<<" \nSimulation complete:"<<endl;
       printf(" $%x was not found \n", memory[0x54]);
       cout<<" "<<instr<<" instructions executed "<<endl;
	    cout<<" "<<clock<<" clock cycles used "<<endl;
	    exit(1);
       break;

       /*Indirect load instruction*/
       case 0xA000:
       instr++;
       ar=memory[ar];
       clock++;
       instr++;
       dr=memory[ar];
       clock++;
       ac=dr;
       break;

       /*Output*/
       case 0xF000:
       cout<<"\n Loading bin_srch.hex into program memory ";
       cout<<" starting at address $02... "<<endl;
       cout<<" Loading data.txt into data memory ";
       cout<<" starting at address $001... "<<endl;
       cout<<" "<<lstsiz<<" data bytes loaded "<<endl;
       cout<<" Initializing pc to 100... "<<endl;
       cout<<" Initialzing ac and ar to 0... "<<endl;
       cout<<" Runing Simulation... "<<endl;
       cout<<" \nSimulation complete:"<<endl;
       printf(" $%x found in memory at address $%x \n",memory[0x54],memory[0x52]);
       cout<<" "<<instr<<" instructions executed "<<endl;
       cout<<" "<<clock<<" clock cycles used "<<endl;
       exit(1);
       break;

	   }

    }

    //Close the 2 files that we opened
    fclose(data_in);
    fclose(mch_code);

    return 0;
    char pause;
	 cin>>pause;

}


